diff --git a/Dockerfile b/Dockerfile
new file mode 100644
index 000000000..8b6deebd5
--- /dev/null
+++ b/Dockerfile
@@ -0,0 +1,68 @@
+FROM ubuntu:22.04
+
+ENV DEBIAN_FRONTEND noninteractive
+
+RUN apt-get update && apt-get -y dist-upgrade
+RUN apt-get -y install \
+ apache2 \
+ mariadb-client \
+ netcat-traditional \
+ libappconfig-perl \
+ libdate-calc-perl \
+ libtemplate-perl \
+ build-essential \
+ libdatetime-timezone-perl \
+ libdatetime-perl \
+ libemail-address-perl \
+ libemail-sender-perl \
+ libemail-mime-perl \
+ libemail-mime-modifier-perl \
+ libdbi-perl \
+ libdbix-connector-perl \
+ libcgi-pm-perl \
+ liblocale-codes-perl \
+ libmath-random-isaac-perl \
+ libmath-random-isaac-xs-perl \
+ libapache2-mod-perl2 \
+ libapache2-mod-perl2-dev \
+ libchart-perl \
+ libxml-perl \
+ libxml-twig-perl \
+ perlmagick \
+ libgd-graph-perl \
+ libtemplate-plugin-gd-perl \
+ libsoap-lite-perl \
+ libhtml-scrubber-perl \
+ libjson-rpc-perl \
+ libdaemon-generic-perl \
+ libtheschwartz-perl \
+ libtest-taint-perl \
+ libauthen-radius-perl \
+ libfile-slurp-perl \
+ libencode-detect-perl \
+ libmodule-build-perl \
+ libnet-ldap-perl \
+ libauthen-sasl-perl \
+ libfile-mimeinfo-perl \
+ libhtml-formattext-withlinks-perl \
+ libgd-dev \
+ libmysqlclient-dev \
+ graphviz \
+ vim-common
+
+# Ubuntu22 doesn't ship new enough versions of a few modules, so get them from CPAN
+RUN cpan install Template::Toolkit Email::Address::XS Email::Sender DBD::MariaDB
+
+WORKDIR /var/www/html
+COPY --chown=root:www-data . /var/www/html
+COPY ./docker/000-default.conf /etc/apache2/sites-available/000-default.conf
+COPY ./docker /root/docker
+
+# we don't want Docker droppings accessible by the web browser since they
+# might contain setup info you don't want public
+RUN rm -rf /var/www/html/docker* /var/www/html/Dockerfile*
+RUN rm -rf /var/www/html/data /var/www/html/localconfig /var/www/html/index.html && \
+    mkdir /var/www/html/data
+RUN a2enmod expires && a2enmod headers && a2enmod rewrite && a2dismod mpm_event && a2enmod mpm_prefork
+EXPOSE 80/tcp
+CMD docker/startup.sh
diff --git a/Dockerfile.mariadb b/Dockerfile.mariadb
new file mode 100644
index 000000000..ee6993640
--- /dev/null
+++ b/Dockerfile.mariadb
@@ -0,0 +1,4 @@
+FROM mariadb:10.6
+COPY docker/my.cnf /etc/my.cnf
+COPY docker/mysql /etc/mysql/conf.d
+RUN apt update && apt -y dist-upgrade
diff --git a/README b/README
index e68afd8e4..b867a994d 100644
--- a/README
+++ b/README
@@ -6,9 +6,6 @@ developed by an active group of volunteers in the Mozilla community, and used
 by thousands of projects and companies around the world. It can be installed on
 Linux and other flavors of Unix, Windows or Mac OS X.
 
-You can try Bugzilla out using our testing installation:
-https://landfill.bugzilla.org/bugzilla-tip/
-
 Documentation
 =============
 
@@ -16,6 +13,15 @@ Bugzilla's comprehensive documentation, including installation instructions,
 can be found here:
 http://www.bugzilla.org/docs/
 
+Docker Quick Start
+==================
+
+If you have Docker installed and just want to take a quick look around Bugzilla
+you can cd into the bugzilla directory (same directory containing this README)
+and type `docker compose up`. The URL to access and the username and password
+for the default admin account will be shown on the console once it finishes
+setting it up.
+
 Reporting Bugs
 ==============
 
diff --git a/admin.cgi b/admin.cgi
index 2ba0cdc7f..f7e6d92cb 100755
--- a/admin.cgi
+++ b/admin.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/attachment.cgi b/attachment.cgi
index d404c85df..651dac6f0 100755
--- a/attachment.cgi
+++ b/attachment.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/buglist.cgi b/buglist.cgi
index 57b593930..df644f6d7 100755
--- a/buglist.cgi
+++ b/buglist.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/chart.cgi b/chart.cgi
index bfbbf300e..fb1fc9c78 100755
--- a/chart.cgi
+++ b/chart.cgi
@@ -27,7 +27,7 @@
 # Bonus:
 # Offer subscription when you get a "series already exists" error?
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -318,15 +318,11 @@ sub plot {
 
   my $format
     = $template->get_format("reports/chart", "", scalar($cgi->param('ctype')));
-  $format->{'ctype'} = 'text/html' if $cgi->param('debug');
 
   $cgi->set_dated_content_disp('inline', 'chart', $format->{extension});
   print $cgi->header($format->{'ctype'});
   disable_utf8() if ($format->{'ctype'} =~ /^image\//);
 
-  # Debugging PNGs is a pain; we need to be able to see the error messages
-  $vars->{'chart'}->dump() if $cgi->param('debug');
-
   $template->process($format->{'template'}, $vars)
     || ThrowTemplateError($template->error());
 }
@@ -362,10 +358,6 @@ sub view {
 
   print $cgi->header();
 
-  # If we have having problems with bad data, we can set debug=1 to dump
-  # the data structure.
-  $chart->dump() if $cgi->param('debug');
-
   $template->process("reports/create-chart.html.tmpl", $vars)
     || ThrowTemplateError($template->error());
 }
diff --git a/checksetup.pl b/checksetup.pl
index 857584937..0dbd95328 100755
--- a/checksetup.pl
+++ b/checksetup.pl
@@ -12,7 +12,7 @@
 # Initialization
 ######################################################################
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -119,6 +119,16 @@ Bugzilla::DB::bz_create_database() if $lc_hash->{'db_check'};
 # now get a handle to the database:
 my $dbh = Bugzilla->dbh;
 
+# We want to catch if the user is trying to "upgrade" from 5.1 because
+# that's actually a downgrade and you can't do that.
+my $bz51install;
+eval { $bz51install = $dbh->bz_index_info('bz_schema', 'bz_schema_version_idx'); };
+if ($bz51install) {
+  require Bugzilla::Error;
+  import Bugzilla::Error;
+  ThrowCodeError("bz51_attempted_upgrade");
+}
+
 # Create the tables, and do any database-specific schema changes.
 $dbh->bz_setup_database();
 
diff --git a/clean-bug-user-last-visit.pl b/clean-bug-user-last-visit.pl
index d9d9f83be..b2f2ee187 100755
--- a/clean-bug-user-last-visit.pl
+++ b/clean-bug-user-last-visit.pl
@@ -19,7 +19,7 @@ It takes no arguments and produces no output except in the case of errors.
 
 =cut
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 use lib qw(. lib);
diff --git a/colchange.cgi b/colchange.cgi
index c5f08b794..281cbfca2 100755
--- a/colchange.cgi
+++ b/colchange.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/collectstats.pl b/collectstats.pl
index f7a926499..47ec919cb 100755
--- a/collectstats.pl
+++ b/collectstats.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/config.cgi b/config.cgi
index 3a939803d..33c10201f 100755
--- a/config.cgi
+++ b/config.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/Bugzilla.pm b/contrib/Bugzilla.pm
index e7452bbb8..6806b36eb 100644
--- a/contrib/Bugzilla.pm
+++ b/contrib/Bugzilla.pm
@@ -4,7 +4,7 @@
 
 package Bugzilla;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/bz_webservice_demo.pl b/contrib/bz_webservice_demo.pl
index bf6d504ad..c6fd77eeb 100755
--- a/contrib/bz_webservice_demo.pl
+++ b/contrib/bz_webservice_demo.pl
@@ -18,7 +18,7 @@ C<bz_webservice_demo.pl --help> for detailed help
 
 =cut
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/bzdbcopy.pl b/contrib/bzdbcopy.pl
index b92d9205d..d77acb93a 100755
--- a/contrib/bzdbcopy.pl
+++ b/contrib/bzdbcopy.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/convert-workflow.pl b/contrib/convert-workflow.pl
index f25bb0ea7..bd3a1a2ee 100755
--- a/contrib/convert-workflow.pl
+++ b/contrib/convert-workflow.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/extension-convert.pl b/contrib/extension-convert.pl
index a70888dc1..fd2daea0e 100755
--- a/contrib/extension-convert.pl
+++ b/contrib/extension-convert.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/fixperms.pl b/contrib/fixperms.pl
index 33b042c66..7e0d5820d 100755
--- a/contrib/fixperms.pl
+++ b/contrib/fixperms.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/merge-users.pl b/contrib/merge-users.pl
index 02129980d..df68a942c 100755
--- a/contrib/merge-users.pl
+++ b/contrib/merge-users.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/mysqld-watcher.pl b/contrib/mysqld-watcher.pl
index 5dbbe320a..57a0f1206 100755
--- a/contrib/mysqld-watcher.pl
+++ b/contrib/mysqld-watcher.pl
@@ -9,7 +9,7 @@
 # mysqld-watcher.pl - a script that watches the running instance of
 # mysqld and kills off any long-running SELECTs against the shadow_db
 #
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/perl-fmt b/contrib/perl-fmt
index 7ac47eeb8..2aef4184a 100755
--- a/contrib/perl-fmt
+++ b/contrib/perl-fmt
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/recode.pl b/contrib/recode.pl
index fdb3ae0ac..8b3b8818d 100755
--- a/contrib/recode.pl
+++ b/contrib/recode.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/sendbugmail.pl b/contrib/sendbugmail.pl
index b1b5fa8a5..bd34d3daf 100755
--- a/contrib/sendbugmail.pl
+++ b/contrib/sendbugmail.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/sendunsentbugmail.pl b/contrib/sendunsentbugmail.pl
index 58bde594c..2a68d843b 100755
--- a/contrib/sendunsentbugmail.pl
+++ b/contrib/sendunsentbugmail.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/contrib/syncLDAP.pl b/contrib/syncLDAP.pl
index 4c75bbc1f..8e82e00f7 100755
--- a/contrib/syncLDAP.pl
+++ b/contrib/syncLDAP.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/createaccount.cgi b/createaccount.cgi
index 0251114e8..b60ae4bb3 100755
--- a/createaccount.cgi
+++ b/createaccount.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/describecomponents.cgi b/describecomponents.cgi
index 19e1af4a5..8817dbae9 100755
--- a/describecomponents.cgi
+++ b/describecomponents.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/describekeywords.cgi b/describekeywords.cgi
index ac18d5f22..d6f07650e 100755
--- a/describekeywords.cgi
+++ b/describekeywords.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/docker/000-default.conf b/docker/000-default.conf
new file mode 100644
index 000000000..8d4d59291
--- /dev/null
+++ b/docker/000-default.conf
@@ -0,0 +1,37 @@
+PerlSwitches -w -T
+ServerName localhost
+<VirtualHost *:80>
+	# The ServerName directive sets the request scheme, hostname and port that
+	# the server uses to identify itself. This is used when creating
+	# redirection URLs. In the context of virtual hosts, the ServerName
+	# specifies what hostname must appear in the request's Host: header to
+	# match this virtual host. For the default virtual host (this file) this
+	# value is not decisive as it is used as a last resort host regardless.
+	# However, you must set it for any further virtual host explicitly.
+ServerName 172.17.0.3
+
+	ServerAdmin webmaster@localhost
+	DocumentRoot /var/www/html
+
+	# Available loglevels: trace8, ..., trace1, debug, info, notice, warn,
+	# error, crit, alert, emerg.
+	# It is also possible to configure the loglevel for particular
+	# modules, e.g.
+	#LogLevel info ssl:warn
+
+	ErrorLog ${APACHE_LOG_DIR}/error.log
+	CustomLog ${APACHE_LOG_DIR}/access.log combined
+
+	# For most configuration files from conf-available/, which are
+	# enabled or disabled at a global level, it is possible to
+	# include a line for only one particular virtual host. For example the
+	# following line enables the CGI configuration for this host only
+	# after it has been globally disabled with "a2disconf".
+	#Include conf-available/serve-cgi-bin.conf
+
+PerlSwitches -w -T
+PerlConfigRequire /var/www/html/mod_perl.pl
+
+</VirtualHost>
+
+# vim: syntax=apache ts=4 sw=4 sts=4 sr noet
diff --git a/docker/my.cnf b/docker/my.cnf
new file mode 100644
index 000000000..1c8dab421
--- /dev/null
+++ b/docker/my.cnf
@@ -0,0 +1,31 @@
+[mysqld]
+#
+# Remove leading # and set to the amount of RAM for the most important data
+# cache in MySQL. Start at 70% of total RAM for dedicated server, else 10%.
+# innodb_buffer_pool_size = 128M
+#
+# Remove leading # to turn on a very important data integrity option: logging
+# changes to the binary log between backups.
+# log_bin
+#
+# Remove leading # to set options mainly useful for reporting servers.
+# The server defaults are faster for transactions and fast SELECTs.
+# Adjust sizes as needed, experiment to find the optimal values.
+# join_buffer_size = 128M
+# sort_buffer_size = 2M
+# read_rnd_buffer_size = 2M
+skip-host-cache
+skip-name-resolve
+datadir=/var/lib/mysql
+socket=/var/lib/mysql/mysql.sock
+secure-file-priv=/var/lib/mysql
+user=mysql
+wait-timeout=28800
+
+# Disabling symbolic-links is recommended to prevent assorted security risks
+symbolic-links=0
+
+log-error=/var/log/mysqld.log
+pid-file=/var/run/mysqld/mysqld.pid
+lower_case_table_names=1
+max_allowed_packet=1G
diff --git a/docker/mysql/bugzilla.cnf b/docker/mysql/bugzilla.cnf
new file mode 100644
index 000000000..6f8ba4778
--- /dev/null
+++ b/docker/mysql/bugzilla.cnf
@@ -0,0 +1,9 @@
+[mysqld]
+max_allowed_packet = 1G
+innodb_file_per_table = ON
+innodb_large_prefix   = ON
+innodb_file_format = Barracuda
+ft_min_word_len = 2
+
+[mysql]
+max_allowed_packet = 1G
diff --git a/docker/startup.sh b/docker/startup.sh
new file mode 100755
index 000000000..205613828
--- /dev/null
+++ b/docker/startup.sh
@@ -0,0 +1,73 @@
+#!/bin/bash
+
+[ -z "$BZ_DB_HOST" ] && echo "Missing Docker Environment, check docker-compose.yml" && exit -1
+cd /var/www/html
+apachectl start
+while :
+do
+  echo "Waiting for database to be available..."
+  nc -z $BZ_DB_HOST $BZ_DB_PORT
+  [ $? -eq 0 ] && break
+  sleep 2
+done
+echo "Checking database..."
+cat - >/root/docker/myclient-root.cnf <<EOF
+[client]
+host='$BZ_DB_HOST'
+port=$BZ_DB_PORT
+user='root'
+password='$MARIADB_ROOT_PASSWORD'
+EOF
+TESTSQL="show databases like '$BZ_DB_NAME'"
+DBEXISTS=`echo "$TESTSQL" | mysql --defaults-file=/root/docker/myclient-root.cnf -BN`
+[ -z "$DBEXISTS" ] && (
+  echo "Database not found, creating..."
+  CREATESQL="
+CREATE DATABASE \`$BZ_DB_NAME\`;
+GRANT SELECT, INSERT,
+UPDATE, DELETE, INDEX, ALTER, CREATE, LOCK TABLES,
+CREATE TEMPORARY TABLES, DROP, REFERENCES ON \`$BZ_DB_NAME\`.*
+TO '$BZ_DB_USER'@'%' IDENTIFIED BY '$BZ_DB_PASS';
+FLUSH PRIVILEGES;
+"
+  echo "$CREATESQL" | mysql --defaults-file=/root/docker/myclient-root.cnf -BN
+)
+echo "Beginning checksetup..."
+perl -pi -e "
+s/%%BZ_ADMIN_EMAIL%%/'${BZ_ADMIN_EMAIL//@/\\@}'/;
+s/%%BZ_ADMIN_PASSWORD%%/'${BZ_ADMIN_PASSWORD//@/\\@//$/\\$}'/;
+s/%%BZ_ADMIN_REALNAME%%/'${BZ_ADMIN_REALNAME//@/\\@//$/\\$}'/;
+s/%%BZ_DB_HOST%%/'$BZ_DB_HOST'/;
+s/%%BZ_DB_PORT%%/$BZ_DB_PORT/;
+s/%%BZ_DB_NAME%%/'$BZ_DB_NAME'/;
+s/%%BZ_DB_USER%%/'$BZ_DB_USER'/;
+s/%%BZ_DB_PASS%%/'${BZ_DB_PASS//@/\\@//$/\\$}'/;
+s@%%BZ_URLBASE%%@'${BZ_URLBASE//@/\\@}'@;
+" /root/docker/checksetup_answers.txt
+perl checksetup.pl /root/docker/checksetup_answers.txt
+echo "Checksetup completed."
+
+LOGIN_USER="Admin user: $BZ_ADMIN_EMAIL"
+LOGIN_PASS="Admin password: $BZ_ADMIN_PASSWORD"
+cat - <<EOF
+#########################################
+##                                     ##
+##  Your Bugzilla installation should  ##
+##         now be reachable at:        ##
+##                                     ##
+EOF
+printf "##%*s%*s##\n" $(( (${#BZ_URLBASE} + 37) / 2)) $BZ_URLBASE $(( 37 - ((${#BZ_URLBASE} + 37) / 2)  )) " "
+cat - <<EOF
+##                                     ##
+EOF
+printf "##%*s%*s##\n" $(( (${#LOGIN_USER} + 37) / 2)) "$LOGIN_USER" $(( 37 - ((${#LOGIN_USER} + 37) / 2)  )) " "
+printf "##%*s%*s##\n" $(( (${#LOGIN_PASS} + 37) / 2)) "$LOGIN_PASS" $(( 37 - ((${#LOGIN_PASS} + 37) / 2)  )) " "
+cat - <<EOF
+##                                     ##
+##   user/password only valid if you   ##
+##    haven't already changed them.    ##
+##                                     ##
+#########################################
+EOF
+# don't exit docker
+while [ 1 ]; do sleep 1000; done
diff --git a/docs/en/rst/conf.py b/docs/en/rst/conf.py
index 34acb4778..9169cb648 100644
--- a/docs/en/rst/conf.py
+++ b/docs/en/rst/conf.py
@@ -113,7 +113,7 @@ rst_prolog = """
 .. role:: field
     :class: field
 
-.. |min-perl-ver| replace:: 5.10.1
+.. |min-perl-ver| replace:: 5.14.0
 """
 
 rst_epilog = """
@@ -128,12 +128,31 @@ them `here <https://bugzilla.mozilla.org/enter_bug.cgi?product=Bugzilla&componen
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'default'
+html_theme = "sphinx_rtd_theme"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+html_theme_options = {
+    #'analytics_id': 'G-XXXXXXXXXX',  #  Provided by Google in your dashboard
+    #'analytics_anonymize_ip': False,
+    'logo_only': True,
+    'display_version': True,
+    'prev_next_buttons_location': 'bottom',
+    'style_external_links': False,
+    'vcs_pageview_mode': '',
+    #'style_nav_header_background': 'white',
+    # Toc options
+    'collapse_navigation': True,
+    'sticky_navigation': True,
+    'navigation_depth': 4,
+    'includehidden': True,
+    'titles_only': False
+}
+
+html_css_files = [
+    "bugzilla.css"
+]
 
 # Add any paths that contain custom themes here, relative to this directory.
 #html_theme_path = []
@@ -145,11 +164,11 @@ html_theme = 'default'
 # A shorter title for the navigation bar.  Default is the same as html_title.
 #html_short_title = None
 
-html_style = "bugzilla.css"
+#html_style = "bugzilla.css"
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-html_logo = "../images/bugzilla.png"
+html_logo = "../images/bugzilla-logo-white.svg"
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
@@ -383,13 +402,10 @@ pdf_fit_background_mode = 'scale'
 # Temporary highlighting of TODO items
 todo_include_todos = False
 
-# The readthedocs.org website cannot access POD.
-on_rtd = os.environ.get('READTHEDOCS', None) == 'True'
-
-if on_rtd:
-    base_api_url = 'https://www.bugzilla.org/docs/5.0/en/html/integrating/api/'
-else:
-    base_api_url = '../integrating/api/'
+# Originally, the readthedocs.org website could not access POD,
+# so we would conditionally override that here if we were building
+# on RTD, but that's no longer the case.
+base_api_url = '../integrating/api/'
 
-extlinks = {'bug': ('https://bugzilla.mozilla.org/show_bug.cgi?id=%s', 'bug  '),
-            'api': (base_api_url + '%s', '')}
+extlinks = {'bug': ('https://bugzilla.mozilla.org/show_bug.cgi?id=%s', 'bug  %s'),
+            'api': (base_api_url + '%s', "%s")}
diff --git a/docs/lib/Pod/Simple/HTML/Bugzilla.pm b/docs/lib/Pod/Simple/HTML/Bugzilla.pm
index 5a2203473..cb29b0bf9 100644
--- a/docs/lib/Pod/Simple/HTML/Bugzilla.pm
+++ b/docs/lib/Pod/Simple/HTML/Bugzilla.pm
@@ -7,11 +7,11 @@
 
 package Pod::Simple::HTML::Bugzilla;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Pod::Simple::HTML);
+use base qw(Pod::Simple::HTML);
 
 # Without this constant, HTMLBatch will throw undef warnings.
 use constant VERSION    => $Pod::Simple::HTML::VERSION;
diff --git a/docs/lib/Pod/Simple/HTMLBatch/Bugzilla.pm b/docs/lib/Pod/Simple/HTMLBatch/Bugzilla.pm
index bc96c9a0e..a156f4d83 100644
--- a/docs/lib/Pod/Simple/HTMLBatch/Bugzilla.pm
+++ b/docs/lib/Pod/Simple/HTMLBatch/Bugzilla.pm
@@ -7,11 +7,11 @@
 
 package Pod::Simple::HTMLBatch::Bugzilla;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Pod::Simple::HTMLBatch);
+use base qw(Pod::Simple::HTMLBatch);
 
 # This is the same hack that HTMLBatch does to "import" this subroutine.
 BEGIN { *esc = \&Pod::Simple::HTML::esc }
diff --git a/docs/makedocs.pl b/docs/makedocs.pl
index 87e346e23..c29b2adcc 100755
--- a/docs/makedocs.pl
+++ b/docs/makedocs.pl
@@ -23,7 +23,7 @@
 # All these TeX packages together are close to a gig :-| But after you've
 # installed them, you can remove texlive-latex-extra-doc to save 400MB.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -33,6 +33,7 @@ BEGIN { chdir dirname($0); }
 use lib qw(.. ../lib lib);
 
 use Cwd;
+use File::Copy qw(copy);
 use File::Copy::Recursive qw(rcopy);
 use File::Find;
 use File::Path qw(rmtree make_path);
@@ -83,12 +84,19 @@ END_HTML
 
   $converter->contents_page_start($contents_start);
   $converter->contents_page_end("</body></html>");
-  $converter->add_css('./../../../../style.css');
+  if (exists($::ENV{'READTHEDOCS'})) {
+    $converter->add_css('./../../style.css');
+  } else {
+    $converter->add_css('./../../../../style.css');
+  }
   $converter->javascript_flurry(0);
   $converter->css_flurry(0);
   make_path('html/integrating/api');
   $converter->batch_convert(['../../'], 'html/integrating/api');
 
+  if (exists($::ENV{'READTHEDOCS'})) {
+    copy('../style.css', 'html/style.css') or die "Copy failed: $!";
+  }
   print "\n";
 }
 
diff --git a/duplicates.cgi b/duplicates.cgi
index 5f22d0084..dff002d6d 100755
--- a/duplicates.cgi
+++ b/duplicates.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editclassifications.cgi b/editclassifications.cgi
index b2797af3d..b9cb36cbd 100755
--- a/editclassifications.cgi
+++ b/editclassifications.cgi
@@ -7,7 +7,7 @@
 # defined by the Mozilla Public License, v. 2.0.
 
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editcomponents.cgi b/editcomponents.cgi
index c0e3b30c0..4997bd0d9 100755
--- a/editcomponents.cgi
+++ b/editcomponents.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editfields.cgi b/editfields.cgi
index 633887db2..57f32ac2e 100755
--- a/editfields.cgi
+++ b/editfields.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editflagtypes.cgi b/editflagtypes.cgi
index edb031fcd..03bbb4424 100755
--- a/editflagtypes.cgi
+++ b/editflagtypes.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editgroups.cgi b/editgroups.cgi
index b93254ebc..8197180b8 100755
--- a/editgroups.cgi
+++ b/editgroups.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -45,10 +45,11 @@ my $token  = $cgi->param('token');
 sub CheckGroupID {
   my ($group_id) = @_;
   $group_id = trim($group_id || 0);
+  my $dbh = Bugzilla->dbh;
   ThrowUserError("group_not_specified") unless $group_id;
   (
-    detaint_natural($group_id) && Bugzilla->dbh->selectrow_array(
-      "SELECT id FROM groups WHERE id = ?",
+    detaint_natural($group_id) && $dbh->selectrow_array(
+      'SELECT id FROM ' . $dbh->quote_identifier('groups') . ' WHERE id = ?',
       undef, $group_id
     )
   ) || ThrowUserError("invalid_group_ID");
diff --git a/editkeywords.cgi b/editkeywords.cgi
index 6b308c15d..ea55270d7 100755
--- a/editkeywords.cgi
+++ b/editkeywords.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editmilestones.cgi b/editmilestones.cgi
index c5f2e8686..2565ccbb5 100755
--- a/editmilestones.cgi
+++ b/editmilestones.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editparams.cgi b/editparams.cgi
index eb34bd53a..2ce0de99c 100755
--- a/editparams.cgi
+++ b/editparams.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editproducts.cgi b/editproducts.cgi
index f98225e6f..1b1b9b6e5 100755
--- a/editproducts.cgi
+++ b/editproducts.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -368,7 +368,7 @@ if ($action eq 'updategroupcontrols') {
                        FROM bugs
                  INNER JOIN bug_group_map
                          ON bug_group_map.bug_id = bugs.bug_id
-                 INNER JOIN groups
+                 INNER JOIN ' . $dbh->quote_identifier('groups') . '
                          ON bug_group_map.group_id = groups.id
                       WHERE groups.id IN (' . join(', ', @now_na) . ')
                         AND bugs.product_id = ? ' . $dbh->sql_group_by('groups.name'),
@@ -390,7 +390,7 @@ if ($action eq 'updategroupcontrols') {
                                 (SELECT bug_group_map.bug_id FROM bug_group_map
                                   WHERE bug_group_map.group_id = groups.id))
                            AS count
-                      FROM groups
+                      FROM ' . $dbh->quote_identifier('groups') . '
                      WHERE groups.id IN (' . join(', ', @now_mandatory) . ')
                      ORDER BY groups.name', {'Slice' => {}}, $product->id
       );
diff --git a/editsettings.cgi b/editsettings.cgi
index 3f0ab6827..4d148a919 100755
--- a/editsettings.cgi
+++ b/editsettings.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editusers.cgi b/editusers.cgi
index 4db7e4441..21e078058 100755
--- a/editusers.cgi
+++ b/editusers.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -708,16 +708,16 @@ sub userDataToVars {
   $vars->{'groups'}    = $user->bless_groups();
 
   $vars->{'permissions'} = $dbh->selectall_hashref(
-    qq{SELECT id,
+    'SELECT id,
                   COUNT(directmember.group_id) AS directmember,
                   COUNT(regexpmember.group_id) AS regexpmember,
-                  (CASE WHEN (groups.id IN ($grouplist)
+                  (CASE WHEN (groups.id IN (' . $grouplist . ')
                               AND COUNT(directmember.group_id) = 0
                               AND COUNT(regexpmember.group_id) = 0
                              ) THEN 1 ELSE 0 END) 
                       AS derivedmember,
                   COUNT(directbless.group_id) AS directbless
-           FROM groups
+           FROM ' . $dbh->quote_identifier('groups') . '
            LEFT JOIN user_group_map AS directmember
                   ON directmember.group_id = id
                  AND directmember.user_id = ?
@@ -733,7 +733,7 @@ sub userDataToVars {
                  AND directbless.user_id = ?
                  AND directbless.isbless = 1
                  AND directbless.grant_type = ?
-          } . $dbh->sql_group_by('id'),
+          ' . $dbh->sql_group_by('id'),
     'id', undef,
     (
       $otheruserid, GRANT_DIRECT, $otheruserid, GRANT_REGEXP,
@@ -742,12 +742,14 @@ sub userDataToVars {
   );
 
   # Find indirect bless permission.
-  $query = qq{SELECT groups.id
-                FROM groups, group_group_map AS ggm
+  $query = 'SELECT groups.id
+                FROM '
+    . $dbh->quote_identifier('groups')
+    . ', group_group_map AS ggm
                 WHERE groups.id = ggm.grantor_id
-                  AND ggm.member_id IN ($grouplist)
+                  AND ggm.member_id IN (' . $grouplist . ')
                   AND ggm.grant_type = ?
-               } . $dbh->sql_group_by('id');
+               ' . $dbh->sql_group_by('id');
   foreach (@{$dbh->selectall_arrayref($query, undef, (GROUP_BLESS))}) {
 
     # Merge indirect bless permissions into permission variable.
diff --git a/editvalues.cgi b/editvalues.cgi
index 59e4d639f..2827b1937 100755
--- a/editvalues.cgi
+++ b/editvalues.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
